//
//  MessagePackUnpacker.m
//  msgpack-objc-ios
//
//  Created by akisute on 11/10/15.
//  Copyright (c) 2011年 akisute. All rights reserved.
//

#import "MessagePackUnpacker.h"


@interface MessagePackUnpacker ()

// TODO: 個々の要素に対してのunpackingメソッドを用意する。個々の要素に対してのunpackingメソッドはパブリックで良い。ステートがそれによって壊れた場合はIO例外でよい。

@end


#pragma mark -


@implementation MessagePackUnpacker

- (id)unpackData:(NSData *)data
{
    // MessagePackInputをdataから生成する
    
    // Unpackメインループ
    // * MessagePackInputにヘッダバイトを読ませて、型を確定させる
    // * 型を確定させたら型の長さを取る。優先はfixedな型（これは一瞬で取れる）、mutableな型の場合はさらにレングスバイトを読ませる
    // * 型と長さを確定させたらデータを読む。
    //   * コレクションの入口・出口・中身を管理させないといけないな。UnpackerStackクラスとかを使うのが良いだろう。
    //   * 単データの場合はそのまま取って返せばOK・・・だが一番最上位がコレクションではない場合はJava版みたいに単純にエラーでよくない？大丈夫？
    //     単データのN個コレクションの場合は先頭の１つ以外復元できないでいいかな？
    return nil;
}

@end
